<?php
if (! defined( 'ABSPATH' )) exit;
class EasyRegistrationForm extends FormInterface
{  
	public static $response_array = array();

	private $formSessionVar = FormSessionVars::ER_DEFAULT_REG;
	
	function handleForm()
	{
		add_action('erf_post_submission_completed', array($this,'smsalert_er_registration_complete'),20);
		add_filter('erf_process_form_html',array($this,'sa_er_handle_js_script'),10,2);
		$this->routeData();
	}
		
	function sa_er_handle_js_script($html,$form)
	{
		if(smsalert_get_option('buyer_signup_otp', 'smsalert_general')=="on")
		{
			$fields = erforms_get_form_input_fields($form['id']);
			$search = array();
			$replace= array();
			foreach($fields as $field){
				if(array_key_exists('addUserFieldMap',$field) && $field['addUserFieldMap']=='billing_phone')
				{
					array_push($search,"id='".$field['name']."'");
					array_push($replace,"id='billing_phone'");
				} 
			}
			$html = str_ireplace($search, $replace, $html); 
			$otp_resend_timer = smsalert_get_option( 'otp_resend_timer', 'smsalert_general', '15');
			$otp_template_style =  smsalert_get_option( 'otp_template_style', 'smsalert_general', 'otp-popup-1.php');
			
			$template = get_smsalert_template('template/'.$otp_template_style,$params=array());
			$html.='<button class="sa-otp-btn-init ninja-forms-field nf-element smsalert_otp_btn_submit" type="button">Verify & Submit</button>'.$template;	
			$html.='<style>.sa-er-hide{display:none !important}</style><script>
	        jQuery(".erf-button button").addClass("sa-er-hide");
			jQuery(".erf-form .sa-otp-btn-init").unbind("click").bind("click", function() {
			    jQuery(this).parents(".smsalertModal").hide();
				var e = jQuery(this).parents("form").find("#billing_phone").val();
				var data = {user_phone:e};
				var action_url = "'.site_url().'/?option=smsalert-er-ajax-verify";
				saInitOTPProcess(this,action_url, data,'.$otp_resend_timer.');
			});
			jQuery(".erf-form .smsalert_otp_validate_submit").unbind("click").bind("click", function() { 
			   var current_form = jQuery(this).parents("form");
				var action_url = "'.site_url().'/?option=smsalert-validate-otp-form";
				var data = current_form.serialize()+"&otp_type=phone&from_both=";
				sa_validateOTP(this,action_url,data,function(){
                 current_form.find(".sa-er-hide").trigger("click")
				});
				return false;		   
			});
			</script>';
		}
		$html .= $this->enqueue_otp_js_script();
		return $html;
	 }
		
	function routeData()
	{
		if(!array_key_exists('option', $_GET)) return;
		switch (trim($_GET['option']))
		{
			case "smsalert-er-ajax-verify":
				$this->_send_otp_er_ajax_verify($_POST);
				exit();
				break;
		}
	}
	
	function _send_otp_er_ajax_verify($getdata)
	{
		SmsAlertUtility::checkSession();
		SmsAlertUtility::initialize_transaction($this->formSessionVar);

		if(array_key_exists('user_phone', $getdata) && !SmsAlertUtility::isBlank($getdata['user_phone']))
		{
			$_SESSION[$this->formSessionVar] = trim($getdata['user_phone']);
			$message = str_replace("##phone##",$getdata['user_phone'],SmsAlertMessages::showMessage('OTP_SENT_PHONE'));
			smsalert_site_challenge_otp('test',null,null,trim($getdata['user_phone']),"phone",null,null,true);
		}
		else
		{
			wp_send_json(SmsAlertUtility::_create_json_response('Enter a number in the following format : 9xxxxxxxxx',SmsAlertConstants::ERROR_JSON_TYPE));
		}
	}
		
	function smsalert_er_registration_complete($submission_id) {
		$submission= erforms()->submission->get_submission($submission_id);
		$user_id = $submission['user']['ID'];
		$user_phone = get_user_meta( $user_id, 'billing_phone', true );
		if($user_phone!='')
		{
		  do_action('smsalert_after_update_new_user_phone', $user_id, $user_phone);
		}
	}

	public static function isFormEnabled() 
	{
		return (smsalert_get_option('buyer_signup_otp', 'smsalert_general')=="on") ? true : false;
	}


	function handle_failed_verification($user_login,$user_email,$phone_number)
	{
		SmsAlertUtility::checkSession();
		if(!isset($_SESSION[$this->formSessionVar])) return;
		if(!empty($_REQUEST['option']) && $_REQUEST['option']=='smsalert-validate-otp-form')
		{
			wp_send_json( SmsAlertUtility::_create_json_response(SmsAlertMessages::showMessage('INVALID_OTP'),'error'));
			exit();
		}
		else
		{
			$_SESSION[$this->formSessionVar] = 'verification_failed';
		}
	}

	function handle_post_verification($redirect_to,$user_login,$user_email,$password,$phone_number,$extra_data)
	{
		SmsAlertUtility::checkSession();
		if(!isset($_SESSION[$this->formSessionVar])) return;
		if(!empty($_REQUEST['option']) && $_REQUEST['option']=='smsalert-validate-otp-form')
		{
			wp_send_json( SmsAlertUtility::_create_json_response("OTP Validated Successfully.",'success'));
			exit();
		}
		else
		{
			$_SESSION[$this->formSessionVar] = 'validated';
		}
	}
	
	function enqueue_otp_js_script()
	{
		wp_register_script( 'smsalert-auth', SA_MOV_URL . 'js/otp-sms.min.js', array('jquery'), SmsAlertConstants::SA_VERSION, true );
		wp_enqueue_script('smsalert-auth');
	}

	public function unsetOTPSessionVariables()
	{
		unset($_SESSION[$this->txSessionId]);
		unset($_SESSION[$this->formSessionVar]);
	}

	public function is_ajax_form_in_play($isAjax)
	{
		SmsAlertUtility::checkSession();
		return isset($_SESSION[$this->formSessionVar]) ? true : $isAjax;
	}


	function handleFormOptions()
	{
	}
}
new EasyRegistrationForm;