<?php
if (! defined( 'ABSPATH' )) exit;

class SAVerify
{
	public static $response_array = array();
	private $formSessionVar = FormSessionVars::SA_SHORTCODE_FORM_VERIFY;

	public function __construct()
	{
		add_shortcode('sa_verify', array($this,'sa_verify_form'), 100);
		add_action('otp_verification_failed', array($this,'handle_failed_verification'), 10,3);
		add_action('otp_verification_successful', array($this,'handle_post_verification'), 10,6);
		$this->routeData();
		add_action('sa_enqueue_otp_js',array($this,'enqueue_otp_js_script'));
		add_filter( 'sa_ajax', array($this,'is_ajax_form_in_play'), 1,1);
	}

	function sa_verify_form($callback){
		$html = '';
		$phone_selector 		= (!empty($callback['phone_selector'])) ? $callback['phone_selector'] : '';
		$submit_selector 		= (!empty($callback['submit_selector'])) ? $callback['submit_selector'] : '';
		$username_selector 		= (!empty($callback['user_selector'])) ? $callback['user_selector'] : '';
		$password_selector 		= (!empty($callback['pwd_selector'])) ? $callback['pwd_selector'] : '';
		
		if (!empty($submit_selector) && !preg_match('/[#.]/', $submit_selector)) {
			$submit_selector = 'input[name='.$submit_selector.']';
		}

		if (!empty($phone_selector) && !preg_match('/[#.]/', $phone_selector)) {
			$phone_selector = 'input[name='.$phone_selector.']';
		}

		$otp_resend_timer 	= smsalert_get_option( 'otp_resend_timer', 'smsalert_general', '15');
		$otp_template_style =  smsalert_get_option( 'otp_template_style', 'smsalert_general', 'otp-popup-1.php');
		
		do_action('sa_enqueue_otp_js');
		
		$template = get_smsalert_template('template/'.$otp_template_style,$params=array());
		$html.= $template;
				
		$html.='<style>.sa-default-btn-hide{display:none !important}</style><script>
		jQuery(window).load(function(){			
			var button = jQuery("'.$submit_selector.'");
			jQuery("'.$submit_selector.'").addClass("sa-default-btn-hide");
			jQuery("'.$submit_selector.'").after(button.clone()).addClass("sa-otp-btn-init smsalert_otp_btn_submit").html();		jQuery(".sa-otp-btn-init").attr("id","sa_verify").attr("name","sa_verify");
			jQuery(".sa-otp-btn-init").removeClass("sa-default-btn-hide");
		});
		jQuery(document).off("click").on("click", ".sa-otp-btn-init",function(){
			
			jQuery(this).parents(".smsalertModal").hide();
			var e 			= jQuery(this).parents("form").find("'.$phone_selector.'").val();			
			var u 			= jQuery(this).parents("form").find("'.$username_selector.'").val();
			var p			= jQuery(this).parents("form").find("'.$password_selector.'").val();
			
			if(typeof u != "undefined" && typeof p != "undefined")
			{
				var data 	= {username:u,password:p};
			}
			else
			{
				var data 	= {user_phone:e};
			}
			var action_url 	= "'.site_url().'/?option='.(($username_selector!='' && $password_selector!='') ? 'smsalert_ajax_login_popup' : 'smsalert-shortcode-ajax-verify').'";
			saInitOTPProcess(this,action_url, data,'.$otp_resend_timer.');
			return false;
		});

		jQuery(document).on("click", ".smsalert_otp_validate_submit",function(){
			var current_form 	= jQuery(this).parents("form");
			var action_url 		= "'.site_url().'/?option=smsalert-validate-otp-form";
			var data 			= current_form.serialize()+"&otp_type=phone&from_both=";
			sa_validateOTP(this,action_url,data,function(){
				current_form.find(".sa-default-btn-hide").not(".sa-otp-btn-init").trigger("click")
			});
			return false;
		});
		</script>';
		return $html;
	}

	public function is_ajax_form_in_play($isAjax)
	{
		SmsAlertUtility::checkSession();
		return isset($_SESSION[$this->formSessionVar]) ? FALSE : $isAjax;
	}

	function routeData()
	{
		if(!array_key_exists('option', $_GET)) return;
		switch (trim($_GET['option']))
		{
			case "smsalert-shortcode-ajax-verify":
				$this->_send_otp_shortcode_ajax_verify($_POST);
				exit();
				break;

			case "smsalert-validate-otp-form":
				$this->shortcode_otp_validate($_POST);
				exit();
				break;
		}
	}

	function shortcode_otp_validate($data){

		do_action('smsalert_validate_otp','smsalert_customer_validation_otp_token');
	}

	function _send_otp_shortcode_ajax_verify($getdata)
	{
		SmsAlertUtility::checkSession();
		SmsAlertUtility::initialize_transaction($this->formSessionVar);
		if(array_key_exists('user_phone', $getdata) && !SmsAlertUtility::isBlank($getdata['user_phone']))
		{
			$phone 		= SmsAlertcURLOTP::checkPhoneNos($getdata['user_phone']);
			$_SESSION[$this->formSessionVar] = $phone;
			$message 	= str_replace("##phone##",$phone,SmsAlertMessages::showMessage('OTP_SENT_PHONE'));
			smsalert_site_challenge_otp('test',null,null,$phone,"phone",null,null,'ajax');
		}
		else
		{
			wp_send_json(SmsAlertUtility::_create_json_response('Enter a number in the following format : 9xxxxxxxxx',SmsAlertConstants::ERROR_JSON_TYPE));
		}
	}

	function handle_failed_verification($user_login,$user_email,$phone_number)
	{
		SmsAlertUtility::checkSession();
		if(!isset($_SESSION[$this->formSessionVar])) return;
		if(!empty($_REQUEST['option']) && $_REQUEST['option']=='smsalert-validate-otp-form')
		{
			wp_send_json( SmsAlertUtility::_create_json_response(SmsAlertMessages::showMessage('INVALID_OTP'),'error'));
			exit();
		}
		else
		{
			$_SESSION[$this->formSessionVar] = 'verification_failed';
		}
	}

	function handle_post_verification($redirect_to,$user_login,$user_email,$password,$phone_number,$extra_data)
	{
		SmsAlertUtility::checkSession();
		if(!isset($_SESSION[$this->formSessionVar])) return;
		if(!empty($_REQUEST['option']) && $_REQUEST['option']=='smsalert-validate-otp-form')
		{
			wp_send_json( SmsAlertUtility::_create_json_response("OTP Validated Successfully.",'success'));
			exit();
		}
		else
		{
			$_SESSION[$this->formSessionVar] = 'validated';
		}
	}
	
	function enqueue_otp_js_script()
	{
		wp_register_script( 'smsalert-auth', SA_MOV_URL . 'js/otp-sms.min.js', array('jquery'), SmsAlertConstants::SA_VERSION, true );
		wp_enqueue_script('smsalert-auth');
	}

	function unsetOTPSessionVariables(){

		unset($_SESSION[$this->txSessionId]);
		unset($_SESSION[$this->formSessionVar]);
	}
}
new SAVerify;