jQuery(document).on("input", ".otp_input",function(){
		enableValidateBtn(this);
});

jQuery(document).on("click", ".close",function(){
	jQuery(this).parents(".smsalertModal").hide();
});

jQuery(document).on('keypress', '.otp_input,.otp-number', function (e) {
    if (e.which == 13) e.preventDefault();
});

function enableValidateBtn(obj,otp_length=0)
{
	if(jQuery(obj).val().match(/^\d{4,8}$/)) {
			jQuery(".smsalert_otp_validate_submit,obj").removeAttr("style");
			jQuery(".smsalert_otp_validate_submit,obj").removeAttr("disabled");
			
	}
	else
	{
		jQuery(".smsalert_otp_validate_submit,obj").css({"color":"grey","pointer-events":"none"});
	}
}

function saResendOTP(obj)
{
	jQuery(obj).text('re-sending..');
	jQuery(obj).parents("form").find(".sa-otp-btn-init").trigger("click");
	return false;
}

function sa_otp_timer(obj,otp_timer=15)
{
	var timer = function(secs){
		var sec_num = parseInt(secs, 10)    
		var hours   = Math.floor(sec_num / 3600) % 24
		var minutes = Math.floor(sec_num / 60) % 60
		var seconds = sec_num % 60    
		hours = hours < 10 ? "0" + hours : hours;
		minutes = minutes < 10 ? "0" + minutes : minutes;
		seconds = seconds < 10 ? "0" + seconds : seconds;
		return [hours,minutes,seconds].join(":")
	};
	obj.find(".sa_timer").show();
	obj.find(".sa_timer").html(timer(otp_timer)+" sec");
	obj.find(".sa_resend_btn").text("Resend");
	var counter = otp_timer;
	 interval = setInterval(function() {
		counter--;
		 var places = (counter < 10 ? "0" : "");
		obj.find(".sa_timer").html(timer(counter)+" sec");
		if (counter == 0) 
		{
			counterRunning=false;
			obj.find(".sa_timer").hide();
			var cssString = "pointer-events: auto; cursor: pointer; opacity: 1; float:right"; 
			obj.find(".sa_resend_btn").attr("style",cssString);
			clearInterval(interval);
		}
		else
		{
			var cssString = "pointer-events: none; cursor: default; opacity: 1; float:right";
			obj.find(".sa_resend_btn").attr("style",cssString);
		}
	}, 1000);
}

function saInitOTPProcess(obj,action_url, data_obj,otp_resend_timer=15,success_cb=null,failure_cb=null)
{
			 var counterRunning=false;
			 var cur_btn 	   = jQuery(obj);
			 var prev_btn_text = cur_btn.val();
			 cur_btn.val("Please wait...");
			 var currentModel 	 = jQuery(obj).parents("form").find(".smsalertModal"); 
			   if(counterRunning){currentModel.show();return false;}
			  
			   
			   $mo = jQuery;
			   var current_form = $mo(obj).parents("form"); 
			   $mo.ajax({
					url:action_url,
					type:"POST",
					data:data_obj,
					crossDomain:!0,
					dataType:"json",
					success:function(o){
					("success"==o.result)?(
					cur_btn.val(prev_btn_text),
					currentModel.find(".otp-input").val(""),
					currentModel.find(".otp-number").val(""),
					currentModel.find(".sa-message").empty().removeClass("woocommerce-error"),
					currentModel.find(".sa-message").append(o.message),
					currentModel.find(".sa-message").addClass("woocommerce-message"),
					currentModel.show(), 
					currentModel.find(".smsalert_validate_field").show(),
					sa_otp_timer(currentModel,otp_resend_timer),
					counterRunning=true,
					((typeof success_cb == "function") ? success_cb(o) : "" )
					):
					(
					currentModel.find(".smsalert_validate_field").hide(),
					currentModel.find(".sa-message").empty(),
					currentModel.find(".sa-message").append(o.message),
					currentModel.find(".sa-message").addClass("woocommerce-error"),
					currentModel.show(),
					cur_btn.val(prev_btn_text)
					)
					
					
					},
					error:function(o,e,m)
					{
						console.log(o);
						cur_btn.val(prev_btn_text);
						((typeof failure_cb == "function") ? failure_cb(o) : "" )
					}
				   });
				   
				   return false;
}

function saInitBlockOTPProcess(obj,action_url, data_obj,otp_resend_timer=15,success_cb=null,failure_cb=null)
{
	var counterRunning=false;
	var cur_btn 	   = jQuery(obj);
	var prev_btn_text = cur_btn.val();
	cur_btn.val("Please wait...");
	var currentModel 	 = jQuery(obj).parents(".entry-content").find(".smsalertModal"); 
	//var currentModel 	 = jQuery(obj).parents(".entry-content").find('.smsalertModal'); 
	if(counterRunning){currentModel.show();return false;}

	$mo = jQuery;
	var current_form = $mo(obj).parents("form"); 
	$mo.ajax({
		url:action_url,
		type:"POST",
		data:data_obj,
		crossDomain:!0,
		dataType:"json",
		success:function(o){
		("success"==o.result)?(
		cur_btn.val(prev_btn_text),
		currentModel.find(".otp-input").val(""),
		currentModel.find(".otp-number").val(""),
		currentModel.find(".sa-message").empty().removeClass("woocommerce-error"),
		currentModel.find(".sa-message").append(o.message),
		currentModel.find(".sa-message").addClass("woocommerce-message"),
		currentModel.show(), 
		currentModel.find(".smsalert_validate_field").show(),
		sa_otp_timer(currentModel,otp_resend_timer),
		counterRunning=true,
		((typeof success_cb == "function") ? success_cb(o) : "" )
		):
		(
		currentModel.find(".smsalert_validate_field").hide(),
		currentModel.find(".sa-message").empty(),
		currentModel.find(".sa-message").append(o.message),
		currentModel.find(".sa-message").addClass("woocommerce-error"),
		currentModel.show(),
		cur_btn.val(prev_btn_text)
		)
		
		
		},
		error:function(o,e,m)
		{
			console.log(o);
			cur_btn.val(prev_btn_text);
			((typeof failure_cb == "function") ? failure_cb(o) : "" )
		}
	});
	   
	return false;
}

function sa_validateOTP(obj,action_url,data_obj,callback)
{
	$mo  =jQuery;
	var current_btn = $mo(obj);
	current_btn.attr("disabled",true);
	var current_form = $mo(obj).parents("form");
	$mo.ajax({
		//url:"'.site_url().'/?option=smsalert-validate-otp-form",
		url:action_url,
		type:"POST",
		//data:current_form.serialize(),
		data:data_obj,
		crossDomain:!0,
		dataType:"json",
		success:function(o){("success"==o.result && o.message=="OTP Validated Successfully.")?
		(
			current_form.find('.smsalertModal').hide(),
			((typeof callback == "function") ? callback() : "" )
		):
		(
		current_btn.attr("disabled",false),
		current_form.find(".sa-message").empty().addClass("woocommerce-error"),
		current_form.find(".sa-message").append(o.message),
		current_form.find(".sa-message").removeClass("woocommerce-message"),
		current_form.find(".otp_input").focus())
		},
		error:function(o,e,m)
		{
			alert("error found here");
		}
	});
}



function sa_validateBlockOTP(obj,action_url,data_obj,callback)
{
	$mo  =jQuery;
	var current_btn = $mo(obj);
	current_btn.attr("disabled",true);
	var current_form = $mo(obj).parents(".smsalertModal");
	$mo.ajax({
		//url:"'.site_url().'/?option=smsalert-validate-otp-form",
		url:action_url,
		type:"POST",
		//data:current_form.serialize(),
		data:data_obj,
		crossDomain:!0,
		dataType:"json",
		success:function(o){("success"==o.result && o.message=="OTP Validated Successfully.")?
		(
			current_form.hide(),
			((typeof callback == "function") ? callback() : "" )
		):
		(
		current_btn.attr("disabled",false),
		current_form.find(".sa-message").empty().addClass("woocommerce-error"),
		current_form.find(".sa-message").append(o.message),
		current_form.find(".sa-message").removeClass("woocommerce-message"),
		current_form.find(".otp_input").focus())
		},
		error:function(o,e,m)
		{
			console.log(o);
			console.log("error"+e);
			console.log("m"+m);
			alert("error found here");
		}
	});
}



function digitGroup(obj)
{
	jQuery(obj).attr("maxlength", 1);
	jQuery(obj).on("keyup", function(e) {
		var parent = jQuery(jQuery(obj).parent());
		if(e.keyCode === 8 || e.keyCode === 37) {
			var prev = parent.find("input#" + jQuery(obj).data("previous"));
			if(prev.length) {
				jQuery(prev).select();
			}
		} else if((e.keyCode >= 48 && e.keyCode <= 57) || (e.keyCode >= 65 && e.keyCode <= 90) || (e.keyCode >= 96 && e.keyCode <= 105) || e.keyCode === 39) {
			var next = parent.find("input#" + jQuery(obj).data("next"));
			if(next.length) {
				jQuery(next).select();
			} 
		}
		
	});
}

jQuery(document).on("change",".smsalertModal .otp-number",function(e) {
	var otp_length = 4;
		var txtData = [];
		var parent = jQuery(this).parents(".smsalertModal");
		parent.find(".otp-number").each(function() {
			var otp_number = jQuery(this).val();
			txtData.push(otp_number);
		});
		parent.find(".otp_input").val(txtData.join(""));
		enableValidateBtn(parent.find(".otp_input"),otp_length);
		e.preventDefault();
});